program RESERVOIR4_4;
{$APPTYPE CONSOLE}
type
  CYLINDER=class
     R,H:Real;
     constructor Create;overload;
     constructor Create(x,y:real);overload;
     function V:Real;Virtual;
     function Price(Pr1km,DDS:real):Real;
  end;

  DCYLINDER=class(CYLINDER)
     R2:Real;
     constructor Create;overload;
     constructor Create(x,y,z:real);overload;
     function V:Real;Override;
  end;

{ CYLINDER }
constructor CYLINDER.Create;
begin
  Repeat
    write('R=');Readln(R)
  Until R>0;
  Repeat
    write('H=');Readln(H)
  Until H>0;
end;

constructor CYLINDER.Create(x,y:real);
begin
   Inherited Create;
   R:=abs(x);
   H:=abs(y)
end;

function CYLINDER.V;
begin
   Result:=pi*R*R*H
end;

function CYLINDER.Price;
begin
   Result:=V*Pr1km*(1+DDS/100)
end;

{ DCYLINDER }
constructor DCYLINDER.Create;
begin
  Inherited;
  Repeat
    write('R2=');Readln(R2)
  Until R2>0;
end;

constructor DCYLINDER.Create(x, y, z: real);
begin
   Inherited Create(x,y);
   R2:=abs(z)
end;

function DCYLINDER.V: Real;
begin
   Result:=pi*H*abs(R*R-R2*R2)
end;

var C:CYLINDER;
    D:DCYLINDER;
    p1,dds:real;
begin
   C:=CYLINDER.Create(1,0.50);
   D:=DCYLINDER.Create;
   Write('Enter the price of 1 c.m. water:');
   Readln(p1);
   Write('Enter the WAT:');
   Readln(dds);
   with C do
   begin
     writeln('Cylindrical reservoir: R=',R:0:2,' H=',H:0:2);
     writeln('Volume:',V:5:2);
     writeln('Total price:',Price(p1,dds):5:2);
   end;
   with D do
   begin
     writeln('Double Cylindrical reservoir: R=',
              R:0:2,' r=',R2:0:2,' H=',H:0:2);
     writeln('Volume:',V:5:2);
     writeln('Total price:',Price(p1,dds):5:2);
   end;
   C.Free;
   D.Free;
   readln
end.

